; ******************************************************************************
; Copyright (C) 2013 Spansion LLC. All Rights Reserved. 
; 
; This software is owned and published by: 
; Spansion LLC, 915 DeGuigne Dr. Sunnyvale, CA  94088-3453 ("Spansion").
; 
; BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND 
; BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
; 
; This software contains source code for use with Spansion 
; components. This software is licensed by Spansion to be adapted only 
; for use in systems utilizing Spansion components. Spansion shall not be 
; responsible for misuse or illegal use of this software for devices not 
; supported herein.  Spansion is providing this software "AS IS" and will 
; not be responsible for issues arising from incorrect user implementation 
; of the software.  
; 
; SPANSION MAKES NO WARRANTY, EXPRESS OR IMPLIED, ARISING BY LAW OR OTHERWISE,
; REGARDING THE SOFTWARE (INCLUDING ANY ACOOMPANYING WRITTEN MATERIALS), 
; ITS PERFORMANCE OR SUITABILITY FOR YOUR INTENDED USE, INCLUDING, 
; WITHOUT LIMITATION, THE IMPLIED WARRANTY OF MERCHANTABILITY, THE IMPLIED 
; WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE OR USE, AND THE IMPLIED 
; WARRANTY OF NONINFRINGEMENT.  
; SPANSION SHALL HAVE NO LIABILITY (WHETHER IN CONTRACT, WARRANTY, TORT, 
; NEGLIGENCE OR OTHERWISE) FOR ANY DAMAGES WHATSOEVER (INCLUDING, WITHOUT 
; LIMITATION, DAMAGES FOR LOSS OF BUSINESS PROFITS, BUSINESS INTERRUPTION, 
; LOSS OF BUSINESS INFORMATION, OR OTHER PECUNIARY LOSS) ARISING FROM USE OR 
; INABILITY TO USE THE SOFTWARE, INCLUDING, WITHOUT LIMITATION, ANY DIRECT, 
; INDIRECT, INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES OR LOSS OF DATA, 
; SAVINGS OR PROFITS, 
; EVEN IF SPANSION HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. 
; YOU ASSUME ALL RESPONSIBILITIES FOR SELECTION OF THE SOFTWARE TO ACHIEVE YOUR
; INTENDED RESULTS, AND FOR THE INSTALLATION OF, USE OF, AND RESULTS OBTAINED 
; FROM, THE SOFTWARE.  
; 
; This software may be replicated in part or whole for the licensed use, 
; with the restriction that this Disclaimer and Copyright notice must be 
; included with each copy of this software, whether used in part or whole, 
; at all times.  
; 
;/*****************************************************************************/
;/*  Startup for IAR                                                          */
;/*  Version     V1.0                                                         */
;/*  Date        2014-01-20                                                   */
;/*  Target-mcu  S6E1XX                                                       */
;/*****************************************************************************/


                MODULE  ?cstartup

                ;; Forward declaration of sections.
                SECTION CSTACK:DATA:NOROOT(3)

                SECTION .intvec:CODE:NOROOT(2)

                EXTERN  __iar_program_start
                EXTERN  SystemInit
                PUBLIC  __vector_table

                DATA
__vector_table  DCD     sfe(CSTACK)               ; Top of Stack
                DCD     Reset_Handler             ; Reset
                DCD     IRQ_Universal //NMI_Handler               ; NMI
                DCD     IRQ_Universal //HardFault_Handler         ; Hard Fault
                DCD     IRQ_Universal //0                         ; MPU Fault
                DCD     IRQ_Universal //0                         ; Bus Fault
                DCD     IRQ_Universal //0                         ; Usage Fault
                DCD     IRQ_Universal //0                         ; Reserved
                DCD     IRQ_Universal //0                         ; Reserved
                DCD     IRQ_Universal //0                         ; Reserved
                DCD     IRQ_Universal //0                         ; Reserved
                DCD     IRQ_Universal //SVC_Handler               ; SVCall
                DCD     IRQ_Universal //0                         ; Debug Monitor
                DCD     IRQ_Universal //0                         ; Reserved
                DCD     IRQ_Universal //PendSV_Handler            ; PendSV
                DCD     IRQ_Universal //SysTick_Handler           ; SysTick

; Numbered IRQ handler vectors

; Note: renaming to device dependent ISR function names are done in
;       pdl.h (section "IRQ name definition for all type MCUs"

                DCD     IRQ_Universal //IRQ000_Handler
                DCD     IRQ_Universal //IRQ001_Handler
                DCD     IRQ_Universal //IRQ002_Handler
                DCD     IRQ_Universal //IRQ003_Handler
                DCD     IRQ_Universal //IRQ004_Handler
                DCD     IRQ_Universal //IRQ005_Handler
                DCD     IRQ_Universal //IRQ006_Handler
                DCD     IRQ_Universal //IRQ007_Handler
                DCD     IRQ_Universal //IRQ008_Handler
                DCD     IRQ_Universal //IRQ009_Handler
                DCD     IRQ_Universal //IRQ010_Handler
                DCD     IRQ_Universal //IRQ011_Handler
                DCD     IRQ_Universal //IRQ012_Handler
                DCD     IRQ_Universal //IRQ013_Handler
                DCD     IRQ_Universal //IRQ014_Handler
                DCD     IRQ_Universal //IRQ015_Handler
                DCD     IRQ_Universal //IRQ016_Handler
                DCD     IRQ_Universal //IRQ017_Handler
                DCD     IRQ_Universal //IRQ018_Handler
                DCD     IRQ_Universal //IRQ019_Handler
                DCD     IRQ_Universal //IRQ020_Handler
                DCD     IRQ_Universal //IRQ021_Handler
                DCD     IRQ_Universal //IRQ022_Handler
                DCD     IRQ_Universal //IRQ023_Handler
                DCD     IRQ_Universal //IRQ024_Handler
                DCD     IRQ_Universal //IRQ025_Handler
                DCD     IRQ_Universal //IRQ026_Handler
                DCD     IRQ_Universal //IRQ027_Handler
                DCD     IRQ_Universal //IRQ028_Handler
                DCD     IRQ_Universal //IRQ029_Handler
                DCD     IRQ_Universal //IRQ030_Handler
                DCD     IRQ_Universal //IRQ031_Handler

                THUMB
; Dummy Exception Handlers (infinite loops which can be modified)

                PUBWEAK Reset_Handler
                SECTION .text:CODE:NOROOT:REORDER(2)
Reset_Handler
                ;0x200017F0 MAGIC WORD ADDRESS IN RAM
                
                LDR     R0,=0x200017F0

                ;IF MAGIC WORD IS BOOT, START DIRECTLY MAIN APPLICATION
                LDRB    r2,[r0,#0x00]
                CMP     R2, #0x42
                BNE.N   Boot_Bootloader
                LDRB    r2,[r0,#0x01]
                CMP     R2, #0x4F
                BNE.N   Boot_Bootloader
                LDRB    r2,[r0,#0x02]
                CMP     R2, #0x4F
                BNE.N   Boot_Bootloader
                LDRB    r2,[r0,#0x03]
                CMP     R2, #0x54
                BNE.N   Boot_Bootloader

                ;DELETE MAGIC WORD
                MOVS    r1,#0x00
                STRB    r1,[r0,#0x00] 
                STRB    r1,[r0,#0x01] 
                STRB    r1,[r0,#0x02] 
                STRB    r1,[r0,#0x03] 
                
                ;LOAD START ADDRESS 0x00004000 
                LDR     R0, =0x00004000
                LDR     r2,[r0,#0x04]
                
                ;CHECK IF VALID RESET VECTOR
                LDRB    r2,[r0,#0x00]
                CMP     R2, #0xFF
                BNE.N   Boot_User_Application
                LDRB    r2,[r0,#0x01]
                CMP     R2, #0xFF
                BNE.N   Boot_User_Application
                LDRB    r2,[r0,#0x02]
                CMP     R2, #0xFF
                BNE.N   Boot_User_Application
                LDRB    r2,[r0,#0x03]
                CMP     R2, #0xFF
                BNE.N   Boot_User_Application
                B       Boot_Bootloader
                
Boot_User_Application
                ;RELOCATE VECTOR TABLE 0xE000ED08
                LDR     R1,=0xE000ED08
                STR     r0,[r1,#0x00]
                
                LDR     R2, [R0]	//Load new stack pointer address
                MOV     SP, R2
                
                LDR     R2, [R0, #4]	//Load new program counter address
                MOV     PC, R2
                
                
Boot_Bootloader
                LDR     R0, =SystemInit
                BLX     R0
                LDR     R0, =__iar_program_start
                BX      R0
/*
NMI_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#8]
                mov     pc, r0

HardFault_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#12]
                mov     pc, r0
                
SVC_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#44]
                mov     pc, r0

PendSV_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#56]
                mov     pc, r0

SysTick_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#60]
                mov     pc, r0

IRQ000_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#64]
                mov     pc, r0

IRQ001_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#68]
                mov     pc, r0

IRQ002_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#72]
                mov     pc, r0

IRQ003_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#76]
                mov     pc, r0

IRQ004_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#80]
                mov     pc, r0

IRQ005_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#84]
                mov     pc, r0

IRQ006_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#88]
                mov     pc, r0

IRQ007_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#92]
                mov     pc, r0

IRQ008_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#96]
                mov     pc, r0

IRQ009_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#100]
                mov     pc, r0

IRQ010_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#104]
                mov     pc, r0

IRQ011_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#108]
                mov     pc, r0

IRQ012_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#112]
                mov     pc, r0

IRQ013_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#116]
                mov     pc, r0

IRQ014_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#120]
                mov     pc, r0

IRQ015_Handler
                ldr     r0, =0x4000
                ldr     r0, [r0,#124]
                mov     pc, r0

IRQ016_Handler
                ldr     r0, =0x4080
                ldr     r0, [r0,#0]
                mov     pc, r0

IRQ017_Handler
                ldr     r0, =0x4080
                ldr     r0, [r0,#4]
                mov     pc, r0

IRQ018_Handler
                ldr     r0, =0x4080
                ldr     r0, [r0,#8]
                mov     pc, r0

IRQ019_Handler
                ldr     r0, =0x4080
                ldr     r0, [r0,#12]
                mov     pc, r0

IRQ020_Handler
                ldr     r0, =0x4080
                ldr     r0, [r0,#16]
                mov     pc, r0

IRQ021_Handler
                ldr     r0, =0x4080
                ldr     r0, [r0,#20]
                mov     pc, r0

IRQ022_Handler
                ldr     r0, =0x4080
                ldr     r0, [r0,#24]
                mov     pc, r0

IRQ023_Handler
                ldr     r0, =0x4080
                ldr     r0, [r0,#28]
                mov     pc, r0

IRQ024_Handler
                ldr     r0, =0x4080
                ldr     r0, [r0,#32]
                mov     pc, r0

IRQ025_Handler
                ldr     r0, =0x4080
                ldr     r0, [r0,#36]
                mov     pc, r0

IRQ026_Handler
                ldr     r0, =0x4080
                ldr     r0, [r0,#40]
                mov     pc, r0

IRQ027_Handler
                ldr     r0, =0x4080
                ldr     r0, [r0,#44]
                mov     pc, r0

IRQ028_Handler
                ldr     r0, =0x4080
                ldr     r0, [r0,#48]
                mov     pc, r0

IRQ029_Handler
                ldr     r0, =0x4080
                ldr     r0, [r0,#52]
                mov     pc, r0

IRQ030_Handler
                ldr     r0, =0x4080
                ldr     r0, [r0,#56]
                mov     pc, r0

IRQ031_Handler
                ldr     r0, =0x4080
                ldr     r0, [r0,#60]
                mov     pc, r0*/
IRQ_Universal
                MRS     r0, PSR
                MOVS    r1, #0x3F
                LDR     r2, =0x4000
                ANDS    r0, r1
                LSLS    r0, r0, #2
                LDR    r0, [r0, r2]
                mov     pc, r0
                
                END
