/************************************************************************/
/*               (C) Fujitsu Semiconductor Europe GmbH (FSEU)           */
/*                                                                      */
/* The following software deliverable is intended for and must only be  */
/* used for reference and in an evaluation laboratory environment.      */
/* It is provided on an as-is basis without charge and is subject to    */
/* alterations.                                                         */
/* It is the user's obligation to fully test the software in its        */
/* environment and to ensure proper functionality, qualification and    */
/* compliance with component specifications.                            */
/*                                                                      */
/* In the event the software deliverable includes the use of open       */
/* source components, the provisions of the governing open source       */
/* license agreement shall apply with respect to such software          */
/* deliverable.                                                         */
/* FSEU does not warrant that the deliverables do not infringe any      */
/* third party intellectual property right (IPR). In the event that     */
/* the deliverables infringe a third party IPR it is the sole           */
/* responsibility of the customer to obtain necessary licenses to       */
/* continue the usage of the deliverable.                               */
/*                                                                      */
/* To the maximum extent permitted by applicable law FSEU disclaims all */
/* warranties, whether express or implied, in particular, but not       */
/* limited to, warranties of merchantability and fitness for a          */
/* particular purpose for which the deliverable is not designated.      */
/*                                                                      */
/* To the maximum extent permitted by applicable law, FSEU's liability  */
/* is restricted to intentional misconduct and gross negligence.        */
/* FSEU is not liable for consequential damages.                        */
/*                                                                      */
/* (V1.5)                                                               */
/************************************************************************/
/** \file bootloader.h
 **
 ** Global file for bootloader settings
 **
 ** History:
 **   - 2014-07-02    1.0  MSc  First version for MB9BF568R and USB Host Mass Storage
 *****************************************************************************/

#ifndef __BOOTLOADER_H__
#define __BOOTLOADER_H__

/******************************************************************************/
/* Include files                                                              */
/******************************************************************************/

#include "bootloaderapi.h"
#include "base_types.h"

/******************************************************************************
 * Global definitions
 ******************************************************************************/

#define BOOTLOADER_USB_DEVICE_CDC       0
#define BOOTLOADER_UART                 1
#define BOOTLOADER_USB_HOST_MASSSTORAGE 0
#define BOOTLOADER_FM0_PDL              1
#define BOOTLOADER_FM4_PDL              0
#define BOOTLOADER_FM3_L3               0

#define S6E1A12C         1
#define USER_FLASH_START 0x00004000


#endif /* __BOOTLOADER_H__*/

/******************************************************************************/
/* EOF (not truncated)                                                        */
/******************************************************************************/

