/*******************************************************************************
* Copyright (C) 2013 Spansion LLC. All Rights Reserved. 
*
* This software is owned and published by: 
* Spansion LLC, 915 DeGuigne Dr. Sunnyvale, CA  94088-3453 ("Spansion").
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND 
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with Spansion 
* components. This software is licensed by Spansion to be adapted only 
* for use in systems utilizing Spansion components. Spansion shall not be 
* responsible for misuse or illegal use of this software for devices not 
* supported herein.  Spansion is providing this software "AS IS" and will 
* not be responsible for issues arising from incorrect user implementation 
* of the software.  
*
* SPANSION MAKES NO WARRANTY, EXPRESS OR IMPLIED, ARISING BY LAW OR OTHERWISE,
* REGARDING THE SOFTWARE (INCLUDING ANY ACOOMPANYING WRITTEN MATERIALS), 
* ITS PERFORMANCE OR SUITABILITY FOR YOUR INTENDED USE, INCLUDING, 
* WITHOUT LIMITATION, THE IMPLIED WARRANTY OF MERCHANTABILITY, THE IMPLIED 
* WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE OR USE, AND THE IMPLIED 
* WARRANTY OF NONINFRINGEMENT.  
* SPANSION SHALL HAVE NO LIABILITY (WHETHER IN CONTRACT, WARRANTY, TORT, 
* NEGLIGENCE OR OTHERWISE) FOR ANY DAMAGES WHATSOEVER (INCLUDING, WITHOUT 
* LIMITATION, DAMAGES FOR LOSS OF BUSINESS PROFITS, BUSINESS INTERRUPTION, 
* LOSS OF BUSINESS INFORMATION, OR OTHER PECUNIARY LOSS) ARISING FROM USE OR 
* INABILITY TO USE THE SOFTWARE, INCLUDING, WITHOUT LIMITATION, ANY DIRECT, 
* INDIRECT, INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES OR LOSS OF DATA, 
* SAVINGS OR PROFITS, 
* EVEN IF SPANSION HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. 
* YOU ASSUME ALL RESPONSIBILITIES FOR SELECTION OF THE SOFTWARE TO ACHIEVE YOUR
* INTENDED RESULTS, AND FOR THE INSTALLATION OF, USE OF, AND RESULTS OBTAINED 
* FROM, THE SOFTWARE.  
*
* This software may be replicated in part or whole for the licensed use, 
* with the restriction that this Disclaimer and Copyright notice must be 
* included with each copy of this software, whether used in part or whole, 
* at all times.  
*/
/*****************************************************************************/
/** \file flashmanagement.c
 **
 ** Stores information about available sectors
 **
 ** History:
 **   - 2014-06-27    1.0  MSc  First version
 *****************************************************************************/

/******************************************************************************/
/* Include files                                                              */
/******************************************************************************/

#include "flashmanagement.h"

/******************************************************************************/
/* Local pre-processor symbols/macros ('#define')                             */
/******************************************************************************/

/******************************************************************************/
/* Global variable definitions (declared in header file with 'extern')        */
/******************************************************************************/

#if defined(MB9BF568R) || \
    defined(MB9BF468R) || \
    defined(MB9BF368R) || \
    defined(MB9BF168R) || \
    defined(MB9BF568N) || \
    defined(MB9BF468N) || \
    defined(MB9BF368N) || \
    defined(MB9BF168N)
const stc_flashmanagement_sector_t astcFlashSectors[] = {{0x4000,8*1024},
                                        {0x6000,8*1024},
                                        {0x8000,32*1024},
                                        {0x10000,64*1024},
                                        {0x20000,64*1024},
                                        {0x30000,64*1024},
                                        {0x40000,64*1024},
                                        {0x50000,64*1024},
                                        {0x60000,64*1024},
                                        {0x70000,64*1024},
                                        {0x80000,64*1024},
                                        {0x90000,64*1024},
                                        {0xA0000,64*1024},
                                        {0xB0000,64*1024},
                                        {0xC0000,64*1024},
                                        {0xD0000,64*1024},
                                        {0xE0000,64*1024},
                                        {0xF0000,64*1024},
                                        {0x100000,64*1024}};
#endif

#if defined(MBAF312K)
const stc_flashmanagement_sector_t astcFlashSectors[] = {{0x4000,8*1024},
                                        {0x4004,8*1024},
                                        {0x8000,48*1024},
                                        {0x8004,48*1024},
                                        {0x20000,64*1024},
                                        {0x20004,64*1024},
                                        {0x40000,64*1024},
                                        {0x40004,64*1024},
                                        {0x60000,64*1024},
                                        {0x60004,64*1024}};
#endif
    
#if defined(S6E1A12C)
const stc_flashmanagement_sector_t astcFlashSectors[] = {{0x4000,8*1024},
                                        {0x6000,32*1024},
                                        {0xE004,32*1024}};
#endif

/******************************************************************************/
/* Local type definitions ('typedef')                                         */
/******************************************************************************/

/******************************************************************************/
/* Local function prototypes ('static')                                       */
/******************************************************************************/

/******************************************************************************/
/* Local variable definitions ('static')                                      */
/******************************************************************************/

/******************************************************************************/
/* Function implementation - global ('extern') and local ('static')           */
/******************************************************************************/

uint32_t FlashManagement_GetSectorCount(void)
{
    return FLASHMANAGEMENT_SECTORCOUNT;
}

/******************************************************************************/
/* EOF (not truncated)                                                        */
/******************************************************************************/
